#!/bin/sh -x
#
# Test sviterbi program
#
# $Author: ggravier $
# $Date: 2003/08/22 14:15:12 $
# $Revision: 1.3 $
#


prog=sviterbi

echo "checking ${prog}:"

if test ! -x ../src/${prog}; then
  echo "  you should probably build ${prog} before running test..."
  exit 1
fi

mkdir -p log

#
# check usage 
#
../src/${prog} --help > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/${prog}.usage > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  usage test passed"
else
  echo "  usage test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check decoding
#
../src/${prog} dat/know.hmm dat/know1.lfcc - > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/vite.1 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  decoding test passed"
else
  echo "  decoding test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

#
# check constrained decoding
#
../src/${prog} -t 10:20 -p 1.0 dat/know.hmm dat/know1.lfcc - > log/${prog}.stdout 2> log/${prog}.stderr
diff log/${prog}.stdout ref/vite.2 > /dev/null 2> /dev/null
if test $? -eq 0 -a x`awk '{print NR}' log/${prog}.stderr | tail -1` = x; then
  echo "  time constrained decoding test passed"
else
  echo "  time constrained decoding test failed (see log/${prog}.stderr for details)"
  exit 1
fi
\rm -f log/*

rmdir log
